/* 󸡺 cgi */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define TOP "================= top ===================="
/* !!! full path of grep !!! */
#define GREP "/usr/local/gnu/bin/grep"
/* !!! full path of spool directory !!! */
#define HOME "/www/htdocs/bbs/spool"

/* !!! <title>  <h1> !!! */
#define TITLE " Search Results"
/* !!! Ǹ <hr> β !!! */
#define FOOT "<b> Archive Search</b><br>\n<address>satodai@dog.intcul.tohoku.ac.jp</address>"


int
GetFileLine( char *line, char **filename )
/* get the filename and line-No portion from the result of grep */
{
    char *s, *t, buf[100];
    int i, len;

    len = strlen( HOME );
    s = line; 
    for( i = 0; i <= len; i++) s++;

    t = buf;
    while( *s != ':' ){
      *t = *s;
      t++; s++;
    }
    *t = '\0';
    *filename = (char *)malloc( sizeof( char ) * (strlen( buf ) + 1) );
    strcpy( *filename, buf );

    t = buf;
    for( s++; *s != ':'; s++ ){
      *t = *s;
      t++;
    }
    *t = '\0';
    return( atoi( buf ) );
}

void
GetName( FILE *fp, char **name )
/* get the string of the author's name */
{
  char *s, *t, buf[1000], line[3000];
  int i, intag = 0, len;

  while ( getc( fp ) != '\n' );
  fgets( line, sizeof( char ) * 2999, fp);

  /* !!! "<b>From: </b>###<br>"  ### ʬʸ *
   * Ǥʤ </b>  <br> δ֤õ ok? !!! */
  len = strlen( line ) - 18;

  t = buf;
  i = 0;
  /* !!! <b>From: </b>  13 ʸ !!! */
  for( s = &line[13]; i < len; s++ ){
    i++;
    switch ( *s ){
      /* tag ̵ */
      case '<':
        intag = 1; break;
      case '>':
        intag = 0; break;
      default:
        if( intag == 0 ){ *t = *s; t++; }
    }
  }
  *t = '\0';
  *name = (char *)malloc( sizeof( char ) * (strlen( buf ) + 1 ) );
  strcpy( *name, buf );
}

void
GetSubject( FILE *fp, char **subj )
/* get the string of subject */
{
  char *s, *t, buf[1000], line[3000];
  int i, intag = 0, len;

  fgets( line, sizeof( char ) * 2999, fp );

  /* !!! "<b>Subject: </b>###<br>"  ### ʬʸ *
   * Ǥʤ </b>  <br> δ֤õ ok? !!! */
  len = strlen( line ) - 21;

  t = buf;
  i = 0;
  /* !!! <b>Subject: </b>  16 ʸ !!! */
  for( s = &line[16]; i < len; s++ ){
    switch ( *s ){
      /* tag ̵ */
      case '<':
        intag = 1; break;
      case '>':
        intag = 0; break;
      default:
        if( intag == 0 ){ *t = *s; t++; }
    }
    i++;
  }
  *t = '\0';
  *subj = (char *)malloc( sizeof( char ) * (strlen( buf ) + 1 ) );
  strcpy( *subj, buf );
}

char *
PutDate( char *s )
/* make DATE string from message ID */
{
    int i;

    putchar( '(' );
    for( i = 0; i < 4; i++ ){ putchar( *s ); s++; }
    putchar( '/' );
    for( i = 0; i < 2; i++ ){ putchar( *s ); s++; }
    putchar( '/' );
    for( i = 0; i < 2; i++ ){ putchar( *s ); s++; }
    putchar( ' ' );
    for( i = 0; i < 2; i++ ){ putchar( *s ); s++; }
    putchar( ':' );
    for( i = 0; i < 2; i++ ){ putchar( *s ); s++; }
    putchar( ':' );
    for( i = 0; i < 2; i++ ){ putchar( *s ); s++; }
    putchar( ')' );

    return( s );
}

void
PutHTHeader( void )
/*** !!! who are you? !!! ***/
{
  puts( "Content-Type: text/html\n" );
  puts( "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">\n");
  puts( "<html lang=\"ja\" dir=\"ltr\">" );
  puts( "<head>" );
  puts( "<LINK REV=\"made\" HREF=\"mailto:satodai@dog.intcul.tohoku.ac.jp\">" );
  puts( "<LINK rel=\"INDEX\" href=\"./index.html\">" );
  puts( "<META NAME=\"Author\" CONTENT=\"Dai Sato\">" );
  puts( "<META name=\"keywords\" content=\"\">" );
  puts( "<META http-equiv=\"Default-Style\" content=\"default\">" );
  puts( "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=x-euc-jp\">" );
  printf( "<title>%s</title></head>\n\n", TITLE );
  printf( "<body bgcolor=\"#bfffff\"><h1>%s</h1>\n", TITLE );
}

PutHTFooter( void )
{
  puts( "<hr>" );
  printf( "%s\n", FOOT );
  puts( "</body></html>" );
}

void
PutHTError( char *s )
{
  puts( "<h2>Error!</h2>" );
  printf( "<p>%s</p>\n", s );
  PutHTFooter();
}

char *
GetMsgID( char *line, char *msg_id )
/* get the message ID */
{
  char *s, *t;

  for( s = line; *s != '\"'; s++ );
  t = msg_id;
  for( s++; *s != '\"'; s++ ){
    *t = *s;
    *t++;
  }
  *t = '\0';

  return( msg_id );
}

void
main( void )
{
  FILE *gp, *fp, *msgp;
  char **vname, **vvalue, *s, *t, tmp[500], grepcmd[500], line[3000], 
    idxline[1000], *filename, prev_file[80], keywd[100], msg_id[50],
    prev_msg_id[50], logfile_line[3000], tmp_filename[150], 
    *subj, *name;
  int i, len, intag, terms, found=0;
  long line_num, prev_line;

  /*** put HTML headers ***/
  PutHTHeader();

  /*** get keywords from URL ***/
  if( Get_Valuables_Get( &vname, &vvalue, &terms ) == NULL ){
    PutHTError( "Search failed. Please contact to the admin of the BBS." );
    exit( 0 );
  }

  for( i = 0; i < 1; i++ ){
    if( strcmp( vname[i], "keywd" ) == 0 ){
      strcpy( keywd, vvalue[i] );
      Decode_Escape( keywd );
      break;
    }
  }
  if( keywd[ 0 ] == '\0' ){
    PutHTError( "ɤƤ硼" );
    exit( 0 );
  }

  /*** grep with keywd into HTML spool files ***/
  if( strchr( keywd, '`' ) != NULL || strchr( keywd, '\"' )
      || strchr( keywd, '\'' ) || strchr( keywd, ';') != NULL ){
    /* (might be) dangerous chars */
    PutHTError( "`, \", \', ; ϻȤʤΤ" );
    exit(0);
  }

  /* !!! оݥեŬ˽񤭴Ʋ !!! */
  sprintf( grepcmd, 
      "%s -ni '%s' %s/until_[0-9]*.html %s/log_sei.html", GREP, keywd, HOME, HOME ); 
  printf( "<p>Your keyword: <b>%s</b></p>\n", keywd );
  if( ( gp = popen( grepcmd, "r" ) ) == NULL ){
    sprintf( tmp, "grep ¹ԤǤʤäΤ<br>%s", grepcmd );
    PutHTError( "tmp" );
    exit(0);
  }

  puts( "<HR>" );

  /*** read lines from 'grep -ni' ***/
  while( fgets( line, sizeof( char ) * 2999, gp ) ){
    line_num = GetFileLine( line, &filename );    
    strcpy( prev_msg_id, msg_id );

    /*** get the Message-ID ***/

    if( strcmp( filename, prev_file ) != 0 ){      /*** new log* file ***/
      strcpy( prev_file, filename );
      if( fp != NULL ) fclose(fp);
      sprintf( tmp_filename, "%s/%s", HOME, filename );
      if( ( fp = fopen( tmp_filename, "r" ) ) == NULL ){
        sprintf( tmp, "ɤ᤺<br>%s", tmp_filename );
        PutHTError( tmp );
        exit( 0 );
      }
      strcpy( logfile_line, "\0" );

      /* forward to the 1st line which includes 'Message ID' */
      for( prev_line = 0; strncmp( logfile_line, "<b>Message-Id:", 14 ) != 0;
           prev_line++ ){
        if( fgets( logfile_line, sizeof( char ) * 900, fp ) == NULL){
          PutHTError( "Message-ID ʤä" );
          exit( 0 );
        }
      }

      /*** get Message ID ***/
      GetMsgID( logfile_line, msg_id );

      /*** get name and subject ***/
      if( name != NULL ) free( name );
      if( subj != NULL ) free( subj );
      GetName( fp, &name );
      GetSubject( fp, &subj );
      prev_line = prev_line + 3;
    }                             /*** end of 'new log* file' ***/


    /*** when matching on the headder of log file ***/
    if( prev_line > line_num ) continue;

    while( fgets( logfile_line, sizeof( char ) * 2999, fp ) != NULL ){
      if( logfile_line[ strlen( logfile_line ) - 1 ] == '\n' )
        prev_line++;
      if( prev_line > line_num ) break;
      if( strncmp( logfile_line, "<b>Message-Id:", 14 ) == 0 ){
        /*** get current Message-ID ***/
        GetMsgID( logfile_line, msg_id );

        if( name != NULL ) free( name );
        if( subj != NULL ) free( subj );
        GetName( fp, &name );
        GetSubject( fp, &subj );
        prev_line = prev_line + 3;
      }
    }
    if( strcmp( prev_msg_id, msg_id ) == 0 ) continue;

    /*** get subject etc. from log* file ***/
    if( found == 0 ){
      found = 1;
      puts( "<h2>ʷǼäΤ</h2>" );
      puts( "<ul>" );
    }

    /* print the info about the article */
    printf( " <li><b>[%s]</b> <br>", name );
    printf( "<a href=\"/bbs/spool/%s#%s\">", filename, msg_id );
    printf( "%s</a>", subj );
    PutDate( msg_id );
    putchar( '\n' );

    free( filename );
  }

  if( found == 0){
    PutHTError( "ΥɤǤϡʤˤ⸫ĤʤΤ" );
    exit( 0 );
  } else {
    pclose( fp );
    puts( "</ul>" );
  }

  PutHTFooter();
}
